<CsoundSynthesizer>
<CsInstruments>
; diskin scrubber 
;;
; -ma++ may 2003

sr = 96000
ksmps = 100
nchnls = 2


	instr 1

; pitch shift stuff
kshift invalue "ShiftPitch"
klastshift init i(kshift)

if (kshift == 0) then
	kpitch = 1
else
	kpitch 	invalue "pitch"
	kpitch	port	kpitch * (.9+rnd(2)), .02, 1
endif
outvalue  "pitchdisplay", kpitch

; other gui input
kgain 	invalue "gain"
kscrub 	invalue "scrub"
kpos		init i(kscrub)

; get file path. 
Sfile invalue "fileName"
SlastFile strcpy Sfile ; i-time 
kres strcmpk Sfile, SlastFile

; if user changed file or position, we have to trigger a reinit
if (kscrub != kpos || klastshift != kshift || kres != 0) then
	kpos = kscrub
	reinit reset	
endif

klastshift = kshift

; this block contains all the i-time stuff that needs to be
; re-initialized when user changes something
reset:
	ilen = 0

	SlastFile strcpy Sfile
	iValid filevalid Sfile
	if (iValid != 0) then
		ilen	filelen Sfile
		ar1, ar2 diskin2 Sfile, kpitch, i(kscrub)*ilen, 1, -1, i(kshift)*16
	else
		
	endif
	
	outvalue "filelen", ilen
rireturn

; only do this block of stuff if we currently have soundfile 
if (iValid != 0) then

	; estimate new position in file
	kpos = kpos + kpitch/(ilen * kr)
	if (kpitch < 0 && kpos < 0) then
		kpos = 1
	elseif (kpitch > 0 && kpos > 1) then
		kpos = 0
	endif
	
	outvalue "scrub", kpos
	outvalue "pos secs", kpos*ilen
	
	; handle gain
	ar1 = ar1*kgain
	ar2 = ar2*kgain
	
	; display rms
	kleft rms ar1
	kright rms ar2
	outvalue "rmsl", kleft/0dbfs
	outvalue "rmsr", kright/0dbfs
	
	; output
	outs ar1, ar2 
endif

	endin








</CsInstruments>
<CsScore>
i1 0 9999


</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
SFDIR: /Users/matt/Music
Functions: None
Listing: Window
WindowBounds: 444 44 1053 845
CurrentView: io
IOViewEdit: Off
Options: -b512 -W -o/Users/matt/Desktop/scrubber.wav -s -m167 -R 
</MacOptions>
<MacGUI>
ioView background {33810, 22510, 21039}
ioSlider {132, 142} {311, 34} 0.000000 1.000000 0.135000 scrub
ioText {407, 193} {71, 113} label 0.000000 0.001000 "" left "Marker Felt" 16 {0, 0, 0} {65535, 65535, 65535} nobackground border Pitch
ioText {322, 193} {82, 114} label 0.000000 0.001000 "" left "Marker Felt" 20 {0, 0, 0} {65535, 65535, 65535} nobackground border Amp
ioText {158, 193} {79, 113} label 0.000000 0.001000 "" left "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground border File Length
ioText {53, 71} {48, 36} label 0.000000 0.001000 "" left "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground noborder File
ioSlider {441, 198} {34, 96} -3.000000 1.000000 1.000000 pitch
ioText {416, 287} {66, 24} display 2.847000 0.001000 "pitchdisplay" right "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioMeter {328, 220} {18, 87} {44563, 53738, 65535} "" 0.000000 "rmsl" 0.000459 fill 1 0 notrack
ioMeter {338, 220} {18, 87} {44563, 53738, 65535} "" 0.000000 "rmsr" 0.000456 fill 1 0 notrack
ioSlider {371, 196} {34, 103} 0.000000 10.000000 3.611000 gain
ioText {361, 286} {48, 24} display 3.611000 0.001000 "gain" right "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {6, 6} {215, 27} label 0.000000 0.001000 "" center "Futura" 12 {48828, 56157, 60918} {31427, 15244, 11814} background border diskin scrubber by ma++
ioText {188, 275} {53, 28} label 0.000000 0.001000 "" center "Marker Felt" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder seconds
ioText {240, 193} {79, 113} label 0.000000 0.001000 "" right "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground border File Peak
ioText {236, 286} {61, 24} display 28219.000000 0.001000 "filepeak" left "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {181, 286} {61, 24} display 421.933319 0.001000 "filelen" right "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {101, 122} {96, 36} label 0.000000 0.001000 "" left "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground noborder Position
ioText {95, 76} {414, 27} label 0.000000 0.001000 "fileName" left "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground border /Users/matt/Music/newPiece/SlotDrum.wav
ioCheckbox {408, 215} {30, 30} on ShiftPitch
ioText {154, 115} {73, 27} display 56.964565 0.001000 "pos secs" left "Futura" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
</MacGUI>
