<CsoundSynthesizer>
<CsInstruments>
; 5.1 surround-file playback and mono strips 
; -ma++ march 2005



; ************ SPECIFY THE NAME OF YOUR SOUNDFILE HERE!!!!! ******************

#define FILE #51.aif#

;  you must either:
;	+ give the full path name
;	+ specify the file's directory in the 'default directory' options
;	+ put the file in the same directory as this 5.1scrubber.csd file

; ****************************************************************************



nchnls = 6


	instr 1

kpitch 	= 1 ;invalue "pitch"	; diskin only suppports 4 channels so 
						; we have to use soundin -- no pitchshift :(
kgain 	invalue "gain"
kgain		port		kgain, .01, 0

kscrub 	invalue "scrub"
kpos		init i(kscrub)

if kscrub != kpos then
	kpos = kscrub
	reinit reset	
endif


ilen	filelen "$FILE"
	outvalue "filelen", ilen

reset:
ar1, ar2, ar3, ar4, ar5, ar6	soundin "$FILE"
rireturn

; estimate new position in file
kpos = kpos + kpitch/(ilen * kr)
if (kpitch < 0 && kpos < 0) then
	kpos = 1
elseif (kpitch > 0 && kpos > 1) then
	kpos = 0
endif

outvalue "scrub", kpos
outvalue "pos secs", kpos*ilen

; handle gain
ar1 = ar1*kgain
ar2 = ar2*kgain
ar3 = ar3*kgain
ar4 = ar4*kgain
ar5 = ar5*kgain
ar6 = ar6*kgain

; display rms
krms1 rms ar1/0dbfs
krms2 rms ar2/0dbfs
krms3 rms ar3/0dbfs
krms4 rms ar4/0dbfs
krms5 rms ar5/0dbfs
krms6 rms ar6/0dbfs

outvalue "rms1", krms1
outvalue "rms2", krms2
outvalue "rms3", krms3
outvalue "rms4", krms4
outvalue "rms5", krms5
outvalue "rms6", krms6

; output
outh ar1, ar2, ar3, ar4, ar5, ar6

skip:
	endin




; strips to mono files -- does it all in one kpass, so will 
; most likely interrupt any real-time audio

	instr 2

kformat invalue "format"
iformat = i(kformat) + 3
ilen	filelen "$FILE"
kcount init 0

loop:
ar1, ar2, ar3, ar4, ar5, ar6	soundin "$FILE"
	fout "$FILE..L", iformat, ar1
	fout "$FILE..R", iformat, ar2
	fout "$FILE..C", iformat, ar3
	fout "$FILE..LF", iformat, ar4
	fout "$FILE..LS", iformat, ar5
	fout "$FILE..RS", iformat, ar6

kcount = kcount + 1
if (kcount/kr <= ilen) kgoto loop

turnoff

	endin
</CsInstruments>
<CsScore>
i1 0 9999


</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: None
Listing: Window
WindowBounds: 162 44 662 500
CurrentView: io
IOViewEdit: Off
Options: -b128 -A -o/Users/matt/Desktop/scrubber.aif -s -m7 -K -R 
</MacOptions>
<MacGUI>
ioView background {33810, 22510, 21039}
ioText {49, 25} {106, 67} label 0.000000 0.001000 "" left "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground noborder File Position
ioText {247, 103} {122, 94} label 0.000000 0.001000 "" right "Marker Felt" 16 {0, 0, 0} {65535, 65535, 65535} nobackground border Amp
ioText {160, 103} {80, 95} label 0.000000 0.001000 "" left "Marker Felt" 24 {0, 0, 0} {65535, 65535, 65535} nobackground border File Length
ioText {99, 73} {59, 27} display 4.717597 0.001000 "pos secs" center "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {162, 166} {61, 24} display 8.000000 0.001000 "filelen" left "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioSlider {322, 126} {34, 64} 0.000000 2.000000 0.909000 gain
ioText {161, 177} {78, 26} label 0.000000 0.001000 "" center "Marker Felt" 12 {0, 0, 0} {65535, 65535, 65535} nobackground noborder seconds
ioButton {81, 260} {119, 62} event 1.000000 "" "Strip To Mono Files" "/" i2 0 999
ioMeter {255, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms1" 0.000000 fill 1 0 notrack
ioMeter {266, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms2" 0.000000 fill 1 0 notrack
ioMeter {277, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms3" 0.000000 fill 1 0 notrack
ioMeter {288, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms4" 0.000000 fill 1 0 notrack
ioMeter {299, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms5" 0.000000 fill 1 0 notrack
ioMeter {310, 110} {17, 80} {44563, 53738, 65535} "" 0.000000 "rms6" 0.000000 fill 1 0 notrack
ioText {340, 121} {33, 24} display 0.909000 0.100000 "gain" right "Lucida Grande" 10 {0, 0, 0} {65535, 65535, 65535} nobackground noborder 
ioText {160, 69} {209, 27} label 0.000000 0.001000 "" center "Futura" 12 {48828, 56157, 60918} {31427, 15244, 11814} background border 5.1 srubber by ma++
ioSlider {95, 25} {311, 34} 0.000000 1.000000 0.589600 scrub
ioMenu {210, 274} {154, 35} 5 202 "16-bit shorts,32-bit ints,32-bit floats,unsigned 8-bit chars,24-bit ints" format
</MacGUI>
