<CsoundSynthesizer>
<CsInstruments>
/**********************************************************************

	MacCsound Tutorial #2
	

	This tutorial explains more MacCsound features.


	+ This tutorial contains the same orc and sco as in
	  Tutorial #1.  This time we will render the project
	  to a soundfile instead.  Notice the icon in the left
	  button in the upper right corner of the window has 
	  changed to a file document icon. [you can click on
  	  the button to change render options].  Press on the
	  green triangle button to render to a file.  After 
	  specifying the file name, the file will be created
	  and open automatically in its own window and begin
	  to playback.  The popup menu in the soundfile window
	  allows you to select processes to run on the file.


	+ Notice some texts here are in different colors:

	  RED text are 'comments', and are specified after a ';' or
	  inside a block of text that starts with a slash-star and ends
	  with a star-slash [like this block of text does].  
	  The Csound process ignores all comments.
 	  Comments come in handy as a way to remind or explain 
	  code to yourself, or to temporarily disable code.
	  
	  [ For all these Tutorials, instructions will be given to
		in commented text ]

	  BLUE text are 'opcodes'.  Opcodes are the Csound objects
	  that create and modify signals/values.  Output values are
	  specified to the left of an opcode.  Input values are listed
	  to the right of an opcode.  You can get documentation about
	  any opcode by selecting it [double click] and then hitting
	  cmd-' [or select 'Lookup selection' from the 'Help' Menu].
	  The default documentation is Kevin Conder's online manual,
	  but you can specify a local version in the prefernces if you
       want.

	  BLACK text are values, variables, and anything else used
	  in Csound code.
	  
	  [ you can change the default color of the syntax in 
	    the preferences window ]

**********************************************************************/



instr my_pluck	; begins instrument definition

	asig pluck .5*0dbfs, 440, 440, 0, 1	; calls the 'pluck' opcode and returns an audio signal

	out asig	; send the signal to the output

endin			; ends instrument definition
</CsInstruments>
<CsScore>
i "my_pluck" 0 2


f1 0 512 10 1 	; a sine wave
f2 0 8 7 0 8 1 	; ramp 0 to 1
</CsScore>

</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: File
Ask: Yes
Functions: ioObject
Listing: ioObject
WindowBounds: 107 44 965 768
CurrentView: orc
IOViewEdit: On
Options: -b512 -A -s -m7 -R 
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioListing {10, 10} {400, 500}
ioGraph {409, 10} {300, 500}
</MacGUI>
